;Update v1.1 - 30.12.2020 - Added undo, Invert Field, y/z x c keyboard shortcuts
;V 1.1 initial release 27.12.2020
;
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=Aut-o-gram.ico
#AutoIt3Wrapper_Outfile=Aut-o-gram-win32.exe
#AutoIt3Wrapper_UseX64=n
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
;Aut-o-Gram - Nonogram in AutoIt
#include <ColorConstants.au3>
#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <GuiConstants.au3>
#include <GUIConstantsEx.au3>
#include <GuiListView.au3>
#include <GuiEdit.au3>
#include <String.au3>
#include <Misc.au3>

#include <Array.au3>

Global $Appname = "Aut-o-Gram", $Appname01 = $Appname
Global $inifile = @ScriptDir & "\" & "Aut-o-Gram.ini"

CW($inifile)

Dim $GameField[15][15]
Dim $PlayField[15][15]

Global $hDLL = DllOpen("user32.dll")
Global Enum $vDim

Global $v_NoFlashingColors
Global $v_GameType = 0
Global $GameLevel = 1
Global Const $maxlevels = 99        ;Let it be 99 levels (per size ! )
Global $doEdit = 0

Global $aColoredLines[$maxlevels][2]

Global $a_Boardinfo[7] = [5, 6, 8, 9, 10, 12, 14]

Global $a_WinColor[] = ["0xd0d0d0", "0xc6d2c5", "0xbfd4bd", "0xb8d6b5", "0xadd9a9", "0x9cde96", "0x8ae282", "0x83e47a", "0x78e76e", "0x67ec5a", "0x63ed55", "0x56f146", "0x52f241", "0x44f632", "0x37fa23"]
Global $GameSplit[7] = [0, 3, 4, 5, 5, 6, 7]            ;Button Spacer info
Global $a_Vinput[14]                                    ;Vertical input boxes
Global $a_Hinput[14]                                    ;Horizontal input boxes
Global $a_Undo[1555]
$a_Undo[0] = 0
Global $boardsize = 30

Global $v_BSize

Global $Form1 = GUICreate($Appname, 540, 550, -1, -1)
GUISetState(@SW_SHOW)

Global $ListW                                ;Global here, bcause WM_NOTIFY needs it ! ;)
GUIRegisterMsg($WM_NOTIFY, "WM_NOTIFY")

While 1
	GameMenu()
	GamePlay()
	$doEdit = 0
WEnd

Func GameMenu()
	WinSetTitle($Form1, "", $Appname)
	Local $a_Radio[7]
	#Region ### START Koda GUI section ### Form=
	$a_Radio[0] = GUICtrlCreateRadio("5x5", 85, 15, 57, 21)
	$a_Radio[1] = GUICtrlCreateRadio("6x6", 85, 57, 57, 21)
	$a_Radio[2] = GUICtrlCreateRadio("8x8", 85, 98, 57, 21)
	$a_Radio[3] = GUICtrlCreateRadio("9x9", 85, 140, 57, 21)
	$a_Radio[4] = GUICtrlCreateRadio("10x10", 85, 182, 57, 21)
	$a_Radio[5] = GUICtrlCreateRadio("12x12", 85, 223, 57, 21)
	$a_Radio[6] = GUICtrlCreateRadio("14x14", 85, 265, 57, 21)
	$ListW = _GUICtrlListView_Create($Form1, "Level |Nr ", 144, 15, 172, 279, BitOR($LVS_REPORT, $LVS_SINGLESEL, $LVS_SHOWSELALWAYS, $LVS_NOSORTHEADER, $LVS_LIST))
	$B_Random = GUICtrlCreateButton("Use Random", 442, 15, 89, 30)
	GUICtrlSetTip(-1, "Generates a random level in the selected size")
	$b_Select = GUICtrlCreateButton("Play Selected", 340, 15, 80, 30)
	$b_edit = GUICtrlCreateButton("Edit", 5, 15, 50, 20)
	$b_CLProg = GUICtrlCreateButton("Clear Progress", 5, 117, 75, 20)
	GUICtrlSetTip(-1, "Clears the current (size) progress" & @CRLF & "from the ini file", "Button Info:")
	$b_quit = GUICtrlCreateButton("Quit", 5, 270, 50, 20)
	$pic = GUICtrlCreatePic("aut-o-gram.jpg", 340, 80, 190, 210)
	$Checkbox = GUICtrlCreateCheckbox("No flashing colors.", 340, 55, 140, 20)
	GUICtrlSetTip(-1, "Stop the changing Colors when the game is won! ")
	Global $EdInfo = GUICtrlCreateEdit("", 5, 300, 530, 245)

	#EndRegion ### END Koda GUI section ###
	_GUICtrlListView_SetColumnWidth($ListW, 1, 0)          ;Hide the number as it is needed only internally
	_GUICtrlListView_SetColumnWidth($ListW, 0, 172)      ;Show only the level
	_GUICtrlListView_SetExtendedListViewStyle($ListW, BitOR($LVS_EX_GRIDLINES, $LVS_EX_FULLROWSELECT, $WS_EX_CLIENTEDGE))

	For $x = 0 To 6
		If $x = $v_GameType Then _CheckUncheck($a_Radio[$x], 1)
	Next
	AddLevelToList()
	WriteInfo()

	$v_NoFlashingColors = IniRead($inifile, "config", "flashing", "1")

	_CheckUncheck($Checkbox, $v_NoFlashingColors)

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE, $b_quit
				DllClose($hDLL)                        ;Close the opened user32.dll and exit
				Exit
			Case $b_CLProg
				ClearProgress($v_GameType)
			Case $Checkbox
				IniWrite($inifile, "config", "flashing", _IsChecked($Checkbox))
				$v_NoFlashingColors = _IsChecked($Checkbox)
			Case $b_edit
				Local $lws = GetSelectedLWITEM()
				If $lws > -1 Then
					$GameLevel = _GUICtrlListView_GetItemText($ListW, $lws, 1)
				Else
					$GameLevel = -1
				EndIf
				$doEdit = 1
				ExitLoop
			Case $B_Random                ;Random button
				$GameLevel = -1
				$doEdit = 0
				ExitLoop
			Case $b_Select                ;Select a level from the Listview
				Local $lws = GetSelectedLWITEM()
				If $lws > -1 Then
					$doEdit = 0
					$GameLevel = _GUICtrlListView_GetItemText($ListW, $lws, 1)
					ExitLoop
				EndIf
			Case Else
				For $x = 0 To 6
					If $nMsg = $a_Radio[$x] Then
						$v_GameType = $x
						$GameLevel = 1
						AddLevelToList()
					EndIf
				Next
		EndSwitch
	WEnd

	For $x = 0 To 6
		GUICtrlDelete($a_Radio[$x])
	Next

	_GUICtrlListView_Destroy($ListW)
	GUICtrlDelete($pic)
	GUICtrlDelete($b_edit)
	GUICtrlDelete($B_Random)
	GUICtrlDelete($b_quit)
	GUICtrlDelete($b_Select)
	GUICtrlDelete($EdInfo)
	GUICtrlDelete($Checkbox)
	GUICtrlDelete($b_CLProg)
	$a_Radio = ""
EndFunc   ;==>GameMenu

Func GetSelectedLWITEM()
	Local $lwc = _GUICtrlListView_GetItemCount($ListW)
	Local $lws = -1
	For $x = 0 To $lwc
		If _GUICtrlListView_GetItemSelected($ListW, $x) = True Then
			$lws = $x
			ExitLoop
		EndIf
	Next
	Return $lws
EndFunc   ;==>GetSelectedLWITEM

Func WriteInfo()

	GUICtrlSetFont($EdInfo, 9, 0, 0, "Inconsolata")


	_GUICtrlEdit_BeginUpdate($EdInfo)
	WTE("", 1)
	WTE("Aut-o-gram, a Nonogram game written in AutoIt 3  - V 1.1 " & @crlf & "(AutoIt forum user: Dan_555) on 27.12.2020")
	WTE("")
	WTE("Button information:")
	WTE("")
	WTE("Edit - Opens the Editor")
	WTE("Clear Progress - Delete the Progress information (Green selection)")
	WTE("Play Selected - Play from the selected level")
	WTE("Use Random: Play a randomly Created nonogram.")
	WTE("")
	WTE("You can disable the changing colors when a level is solved,")
	WTE("by clicking on the 'No Flashing colors' checkbox.")
	WTE("")
	WTE("Game and editor functions:")
	WTE(" Press Y/Z, X or C to change the marker type (Empty, X, Square) - " & @crlf & " X is not available in the editor!")
	WTE("Undo Button undoes the last move. The editor keeps the undo data after Loading.")
	WTE("")
	WTE("Playing the Game:")
	WTE("")
	WTE("Click on the Grey, X or Black button to select a drawing type then try to solve the")
	WTE("level, by clicking on the Squares. The Numbers above and to the left")
	WTE("of the Game field display the available Squares in a Row/Column")
	WTE("")
	WTE("When the Level is solved, the Titlebar will display a Moving Text, and the ")
	WTE("playfield will either constantly change colors, or change to white.")
	WTE("You can automatically load the next level, by clicking on the Play button")
	WTE("")
	WTE("Editor buttons:")
	WTE("")
	WTE("Editor buttons are disabled/hidden when playing the Game!")
	WTE("")
	WTE("Black/Grey Square buttons (Top Left side) selects the drawing metod for the level")
	WTE("Quit - Double click on the Quit Button or on the X to exit!")
	WTE("+-   - change the level number by 1. Hold Shift while clicking on them to increase ")
	WTE("       level number by 10 this is displayed by the L: near the quit button.")
	WTE("Load - read in the level number from the ini file. If the L: shows a -1, a randomly " & @crlf & "       created level will be made.")
	WTE("Save - Save the current level to the ini file. ")
	WTE("       The title displays the loaded level. To avoid wrong overwrites, compare " & @crlf & "       the titlescreen with the L: display")
	WTE("       if a level exists, you will be prompted to either overwrite it, " & @crlf & "       or to save it on a free Spot")
	WTE("       If a save was sucessful, the L: near the quit button will display " & @crlf & "       the new level number")
	WTE("       If a save was not successful, the L: will display a -1")
	WTE("CLS  - The current level composition will be emptied.")
	WTE("Rev  - Color-swaps (invert) the current tiles.")

	_GUICtrlEdit_EndUpdate($EdInfo)
	;GUICtrlSetState($EdInfo, $GUI_DISABLE)
EndFunc   ;==>WriteInfo

Func WTE($txt, $Clear = 0)    ;Write to editbox
	If $Clear = 1 Then
		GUICtrlSetData($EdInfo, "", $Clear)
	Else
		GUICtrlSetData($EdInfo, $txt & @CRLF, 0)
	EndIf
EndFunc   ;==>WTE

Func AddLevelToList()
	Local $tmp = ""
	_GUICtrlListView_BeginUpdate($ListW)
	_GUICtrlListView_DeleteAllItems($ListW)
	Local $z = 0
	For $x = 1 To $maxlevels
		$tmp = IniRead($inifile, "GAME" & $v_GameType, "Level" & $x, "")
		If $tmp <> "" Then
			_GUICtrlListView_AddItem($ListW, "Level " & $x)
			_GUICtrlListView_AddSubItem($ListW, $z, $x, 1)
			If ReadProgress($x) = 1 Then                      ;Color the item by progress
				$aColoredLines[$x - 1][0] = $x - 1
				$aColoredLines[$x - 1][1] = 0x00ff00
			Else
				$aColoredLines[$x - 1][0] = $x - 1
				$aColoredLines[$x - 1][1] = 0x5050FF
			EndIf
			$z = $z + 1
		EndIf
		If $x = $GameLevel Then _GUICtrlListView_SetItemSelected($ListW, $z - 1, True)
	Next
	If $GameLevel < 0 Or $GameLevel >= $x Then _GUICtrlListView_SetItemSelected($ListW, 0, True)

	_GUICtrlListView_EndUpdate($ListW)
EndFunc   ;==>AddLevelToList

Func ClearProgress($game)

	If MsgBox(8228, "Clear Progress ?", "Do you really want to reset the progress indicator ?") = 6 Then
		IniDelete($inifile, "PROGRESS-GAME" & $game)
		AddLevelToList()
	EndIf

EndFunc   ;==>ClearProgress

Func SaveProgress($lvl)
	If $lvl > 0 Then IniWrite($inifile, "PROGRESS-GAME" & $v_GameType, "Level" & $lvl, "done")
EndFunc   ;==>SaveProgress

Func ReadProgress($lvl)
	Local $tmp = IniRead($inifile, "PROGRESS-GAME" & $v_GameType, "Level" & $lvl, "none")
	If $tmp = "done" Then Return 1
	Return 0
EndFunc   ;==>ReadProgress

Func GamePlay()
	Local $level
	$v_BSize = $a_Boardinfo[$v_GameType]
	MakeBoard($v_BSize)
	Local $edit = -1
	Local $tmpname = ""
	Local $gameWonTimer = TimerInit()
	Local $effx = 0, $effy = 0, $effc = 0, $effcr = 0
	Global $marker = 2
	Global $a_Radio[3]
	Local $b_quit = GUICtrlCreateButton("Quit", 0, 0, 30, 15)
	GUICtrlSetTip(-1, "Double click to quit")
	Global $b_edit = GUICtrlCreateButton("Edit", 73, 0, 32, 20)
	GUICtrlSetTip(-1, "Click to Play the next Level")
	GUICtrlSetBkColor($b_edit, "0xF0F0F0")
	Global $b_save = GUICtrlCreateButton("Save", 70, 62, 35, 15)
	Global $b_load = GUICtrlCreateButton("Load", 35, 86, 35, 15)
	GUICtrlSetTip(-1, "Loads a new level." & @CRLF & "Does not reset undo buffer !", "Info:")
	Global $b_rev = GUICtrlCreateButton("Rev", 38, 45, 30, 15)
	GUICtrlSetTip(-1, "Reverse the current level")
	Global $b_pl = GUICtrlCreateButton("+", 80, 82, 25, 25)
	GUICtrlSetTip(-1, "Increase the level #" & @CRLF & "Hold shift for 10 steps")
	Global $b_mi = GUICtrlCreateButton("-", 01, 82, 25, 25)
	GUICtrlSetTip(-1, "Lower the level #" & @CRLF & "Hold shift for 10 steps")

	Local $b_cls = GUICtrlCreateButton("CLS", 0, 62, 35, 15)
	Local $label = GUICtrlCreateLabel("", 35, 0, 35, 15)
	If $doEdit = 1 Then
		Local $b_undo = GUICtrlCreateButton("Undo", 35, 62, 35, 15)
	Else
		Local $b_undo = GUICtrlCreateButton("Undo", 65, 62, 35, 25)
	EndIf

	Local $b_Empty = GUICtrlCreateButton(" ", 0, 22, 35, 22)
	GUICtrlSetBkColor(-1, "0xd0d0d0")
	Global $b_X = GUICtrlCreateButton("X", 35, 22, 35, 22)
	GUICtrlSetFont(-1, 30, 400, 0, "Terminal")
	GUICtrlSetBkColor(-1, "0xf0f0f0")
	Local $b_Square = GUICtrlCreateButton(Chr(219), 70, 22, 35, 22)
	GUICtrlSetFont(-1, 30, 400, 0, "Terminal")
	GUICtrlSetBkColor(-1, $COLOR_BLACK)

	GUICtrlSetData($label, "L: " & $GameLevel)
	$level = $GameLevel
	Local $quittimer = TimerInit()

	For $x = 0 To 2
		$a_Radio[$x] = GUICtrlCreateRadio("", 10 + (35 * $x), 44, 15, 15)
		GUICtrlSetState($a_Radio[$x], $GUI_DISABLE)
	Next
	_CheckUncheck($a_Radio[$marker], 1)

	$level = LoadLvl($level, $doEdit)

	If $doEdit = 0 Then
		EditControl()
		WinSetTitle($Form1, "", $Appname & " - Playing lvl:" & $level)
	Else
		GUICtrlSetState($b_X, $GUI_Hide)
		GUICtrlSetState($a_Radio[1], $GUI_Hide)
		GUICtrlSetState($b_edit, $GUI_DISABLE)
		WinSetTitle($Form1, "", $Appname & " - Edit Mode - Loaded level: " & $level)
	EndIf

	Local $gameWon = 0, $GameWonFlip = -1, $GameWonX = 0
	$a_Undo[0] = 0                   ;Reset the Undo buffer
	AddUndo()                        ;Get the first level setup
	While 1                                                ;Game loop

		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE, $b_quit
				If $edit = -1 Then
					$edit = -$edit
					$quittimer = TimerInit()
				Else
					If TimerDiff($quittimer) <= 1400 Then
						ExitLoop
					Else
						$edit = -1
						$quittimer = TimerInit()
					EndIf
				EndIf
			Case $b_undo
				Undo()
				If $doEdit = 1 Then CalcBoard()
			Case $b_rev
				AddUndo()
				InvertLevel()
				CalcBoard()
			Case $b_edit            ;Load next level
				$level = LoadLvl($level + 1, -1)
				GUICtrlSetData($label, "L: " & $level)
				If $level > 0 Then $GameLevel = $level
				GUICtrlSetState($b_edit, $GUI_DISABLE)
				$gameWon = 0
				WinSetTitle($Form1, "", $Appname & " - Playing lvl:" & $level)
				GUICtrlSetBkColor($b_edit, "0xF0F0F0")
				$a_Undo[0] = 0                            ;Reset the undo buffer
				AddUndo()
			Case $b_pl            ;Level + button
				If $level < 0 Then $level = 0
				$level = (_IsPressed("10", $hDLL) = True) ? $level + 10 : $level + 1
				If $level > $maxlevels Then $level = $maxlevels
				GUICtrlSetData($label, "L: " & $level)
			Case $b_mi            ;Level - button
				$level = (_IsPressed("10", $hDLL) = True) ? $level - 10 : $level - 1
				If $level < 1 Then $level = 1
				GUICtrlSetData($label, "L: " & $level)
			Case $b_cls
				AddUndo()
				For $y = 0 To $v_BSize - 1
					For $x = 0 To $v_BSize - 1
						GUICtrlSetData($GameField[$x][$y], " ")
						GUICtrlSetBkColor($GameField[$x][$y], "0xd0d0d0")
					Next
				Next
				If $doEdit = 1 Then CalcBoard()
			Case $b_save
				$level = SaveLevel($level)
				GUICtrlSetData($label, "L: " & $level)
			Case $b_load
				AddUndo()
				$level = LoadLvl($level, 1)
				GUICtrlSetData($label, "L: " & $level)
				If $level > 0 Then
					$GameLevel = $level
					$tmpname = $GameLevel
				Else
					$tmpname = "Random Generated"
				EndIf
				WinSetTitle($Form1, "", $Appname & " - Edit Mode - Loaded level: " & $tmpname)
			Case $b_Empty
				$marker = 0
				_CheckUncheck($a_Radio[0], 1)
			Case $b_X
				$marker = 1
				_CheckUncheck($a_Radio[1], 1)
			Case $b_Square
				$marker = 2
				_CheckUncheck($a_Radio[2], 1)
			Case Else
				If $nMsg > 0 Then

					For $btny = 0 To $v_BSize - 1                    ;Check Board buttons:
						For $btnx = 0 To $v_BSize - 1
							If $nMsg = $GameField[$btnx][$btny] Then
								AddUndo()
								If $marker = 0 Then
									GUICtrlSetData($GameField[$btnx][$btny], " ")
									GUICtrlSetBkColor($GameField[$btnx][$btny], "0xd0d0d0")
								EndIf
								If $marker = 1 Then
									GUICtrlSetData($GameField[$btnx][$btny], "X")
									GUICtrlSetBkColor($GameField[$btnx][$btny], "0xf0f0f0")
								EndIf
								If $marker = 2 Then
									GUICtrlSetData($GameField[$btnx][$btny], Chr(219))
									GUICtrlSetBkColor($GameField[$btnx][$btny], "0x000000")
								EndIf
								If $doEdit = 1 Then    ;Edit flag is set -
									CalcBoard()                            ;Display the numbers while editing
								Else                ;Play the Game
									If CalcWin() = 1 Then                ;Check for the Winning !
										If $gameWon = 0 Then            ;Ignore adding x'es and " " (for the Title Win-Animation)
											$gameWon = 1
											$GameWonFlip = -1
											$GameWonX = 0
											$effx = 0
											$effc = 0
											$effcr = 0
											GUICtrlSetState($b_edit, $GUI_ENABLE)
											GUICtrlSetBkColor($b_edit, "0x00FF00")
											If ReadProgress($level) = 0 Then SaveProgress($level)
										EndIf
									Else
										WinSetTitle($Form1, "", $Appname & " - Playing lvl:" & $level)
										$gameWon = 0
										$gameWonTimer = TimerInit()
									EndIf
								EndIf
							EndIf
						Next
					Next
				EndIf
		EndSwitch

		If $gameWon = 1 Then


			If TimerDiff($gameWonTimer) > 550 Then        ;Flashing Colors!
				If $v_NoFlashingColors = 0 Then
					For $y = 0 To $v_BSize - 1
						For $x = 0 To $v_BSize - 1
							$tmpname = GUICtrlRead($GameField[$x][$y])
							If $tmpname <> Chr(219) Then
								GUICtrlSetBkColor($GameField[$x][$y], $a_WinColor[$effc])
								GUICtrlSetData($GameField[$x][$y], " ")
							EndIf
						Next
					Next
					If $effcr = 0 Then $effc = $effc + 1
					If $effcr = 1 Then $effc = $effc - 1
					If $effc = 14 Then $effcr = 1
					If $effc = 0 Then $effcr = 0
					$gameWonTimer = TimerInit()
				ElseIf $effx = 0 Then
					For $y = 0 To $v_BSize - 1
						For $x = 0 To $v_BSize - 1
							$tmpname = GUICtrlRead($GameField[$x][$y])
							If $tmpname <> Chr(219) Then
								GUICtrlSetData($GameField[$x][$y], " ")
								GUICtrlSetBkColor($GameField[$x][$y], "0xFFFFFF")
							EndIf
						Next
					Next
					$effx = 1
				EndIf
			EndIf
			; Scrolling Title
			If $GameWonFlip = -1 Then
				$GameWonX = $GameWonX + 0.3
				If $GameWonX > 40 Then $GameWonFlip = -$GameWonFlip
			Else
				$GameWonX = $GameWonX - 0.3
				If $GameWonX <= 0 Then $GameWonFlip = -$GameWonFlip
			EndIf

			$tmpname = _StringRepeat(" ", $GameWonX) & "Well Done"
			$Appname01 = $tmpname
			WinSetTitle($Form1, "", $Appname01)
		EndIf

        If WinActive($Form1) Then
		If _IsPressed("43", $hDLL) Then                  ;C - Square marker
			$marker = 2
			_CheckUncheck($a_Radio[2], 1)
		EndIf
		If _IsPressed("58", $hDLL) And $doEdit <> 1 Then            ;x			- X marker
			$marker = 1
			_CheckUncheck($a_Radio[1], 1)
		EndIf
		If _IsPressed("59", $hDLL) or _IsPressed("5A",$hDLL) Then                  ;y or z ( empty field)

			$marker = 0
			_CheckUncheck($a_Radio[0], 1)
		EndIf
		EndIf

	WEnd

	EraseBoard()

	For $x = 0 To 2
		GUICtrlDelete($a_Radio[$x])
	Next

	GUICtrlDelete($b_save)
	GUICtrlDelete($b_edit)
	GUICtrlDelete($b_load)
	GUICtrlDelete($b_mi)
	GUICtrlDelete($b_pl)
	GUICtrlDelete($b_cls)
	GUICtrlDelete($b_quit)
	GUICtrlDelete($b_Empty)
	GUICtrlDelete($b_X)
	GUICtrlDelete($b_Square)
	GUICtrlDelete($label)
	GUICtrlDelete($b_rev)
	GUICtrlDelete($b_undo)
	$a_Radio = ""
EndFunc   ;==>GamePlay

Func EditControl()        ;Disable-Enable a bunch of controls
	GUICtrlSetState($b_save, $GUI_Hide)
	GUICtrlSetState($b_edit, $GUI_DISABLE)
	GUICtrlSetState($b_load, $GUI_Hide)
	GUICtrlSetState($b_mi, $GUI_Hide)
	GUICtrlSetState($b_pl, $GUI_Hide)
	GUICtrlSetState($b_rev, $GUI_Hide)
	GUICtrlSetData($b_edit, "Play")
EndFunc   ;==>EditControl

Func CW($txt, $crlf = 1)
	Local $nl = ""
	If $crlf = 1 Then $nl = @CRLF
	ConsoleWrite($txt & $nl)
EndFunc   ;==>CW

Func MakeBoard($size)            ;Creates the board buttons
	$xadd = 0
	$yadd = 0
	Local $xs = 100
	Local $ys = 110
	Local $gs = $boardsize

	For $y = 0 To $size - 1
		;if $y=2 or $y=4 or $y=6 then $yadd=$yadd+3
		If $y = $GameSplit[$v_GameType] Then $yadd = $yadd + 2
		For $x = 0 To $size - 1
			;if $x=2 or $x=4 or $x=6 then $xadd=$xadd
			If $x = $GameSplit[$v_GameType] Then $xadd = $xadd + 2
			$tmptxt = "" ;ChrW(219)

			$GameField[$x][$y] = GUICtrlCreateButton($tmptxt, $xs + ($x * $gs) + $xadd, $ys + ($y * $gs) + $yadd, $gs, $gs)
			GUICtrlSetFont(-1, 40, 400, 0, "Terminal")
			GUICtrlSetBkColor(-1, "0xd0d0d0")
		Next
		$xadd = 0
	Next

	For $x = 0 To $size - 1
		$a_Hinput[$x] = GUICtrlCreateInput("", 10, 116 + ($x * $gs), 80, 20, BitOR($ES_READONLY, $ES_RIGHT))
	Next

	For $x = 0 To $size - 1
		;$a_Vinput[$x] = GUICtrlCreateInput("", 107 + ($x * $gs), 05, 20, 100, BitOR($es_multiline, $ES_READONLY))
		$a_Vinput[$x] = GUICtrlCreateEdit("", 107 + ($x * $gs), 05, 20, 100, BitOR($es_multiline, $ES_READONLY))
	Next
EndFunc   ;==>MakeBoard

Func EraseBoard()            ;Deletes the board buttons
	Local $size = $v_BSize

	For $y = 0 To $size - 1
		For $x = 0 To $size - 1
			GUICtrlDelete($GameField[$x][$y])
		Next
		GUICtrlDelete($a_Hinput[$y])
		GUICtrlDelete($a_Vinput[$y])
	Next
EndFunc   ;==>EraseBoard

Func SaveLevel($level)
	Local $z = 0
	Local $tmp = "", $tmplvl = ";"
	Local $saveit = 1
	If $level < 1 Or $level > $maxlevels Then $level = FindFreeLVL() ;In case a negative (random) level number was passed

	$tmp = IniRead($inifile, "GAME" & $v_GameType, "Level" & $level, "")          ;See if the level allready exist in the ini file
	If $tmp <> "" Then               ;level exists, ask for overwrite

		If MsgBox(270388, "Level " & $level & " Exists", "Do you want to overwrite it ?" & @CRLF & "No will seek next spot, if available!") = 7 Then
			$z = FindFreeLVL()
			If $z = 0 Then
				$saveit = 0
			Else
				$level = $z
			EndIf
		EndIf
	EndIf

	If $saveit = 1 Then
		$z = 0
		For $y = 0 To $v_BSize - 1
			For $x = ($v_BSize - 1) To 0 Step -1
				$tmp = GUICtrlRead($GameField[$x][$y])
				If $tmp = Chr(219) Then
					$z = Bit_Set($z, $v_BSize - $x)
				EndIf
			Next
			$tmplvl = $tmplvl & $z & ";"
			$z = 0
		Next
		IniWrite($inifile, "GAME" & $v_GameType, "Level" & $level, $tmplvl)
		Return $level
	EndIf

	Return -1
EndFunc   ;==>SaveLevel

Func BoardToString()
	Local $z = 0
	Local $tmplvl = ";", $tmp = "", $tmptxt = ""
	For $y = 0 To $v_BSize - 1
		$tmptxt = ""
		For $x = 0 To ($v_BSize - 1)
			$tmp = GUICtrlRead($GameField[$x][$y])
			If $tmp = " " Then $tmptxt = $tmptxt & "0"
			If $tmp = "X" Then $tmptxt = $tmptxt & "1"
			If $tmp = Chr(219) Then $tmptxt = $tmptxt & "2"
		Next
		$tmplvl = $tmplvl & $tmptxt & ";"
		$z = 0
	Next
	Return $tmplvl
EndFunc   ;==>BoardToString

Func StringToBoard($tmplvl)
	Local $z = 0
	Local $tmp = ""
	Local $a_a = _StringBetween($tmplvl, ";", ";")
	If @error = 0 Then
		For $y = 0 To $v_BSize - 1
			$tmp = ""
			For $x = 0 To ($v_BSize - 1)
				$tmp = StringMid($a_a[$y], $x + 1, 1)
				If $tmp = 0 Then                  ;" "
					GUICtrlSetData($GameField[$x][$y], " ")
					GUICtrlSetBkColor($GameField[$x][$y], "0xd0d0d0")
				EndIf
				If $tmp = 1 Then                  ;"X"
					GUICtrlSetData($GameField[$x][$y], "X")
					GUICtrlSetBkColor($GameField[$x][$y], "0xf0f0f0")
				EndIf
				If $tmp = 2 Then                  ;Chr(219)
					GUICtrlSetData($GameField[$x][$y], Chr(219))
					GUICtrlSetBkColor($GameField[$x][$y], "0x000000")
				EndIf
			Next
		Next
	EndIf
EndFunc   ;==>StringToBoard

Func AddUndo()
	Local $tmp = ""
	If $a_Undo[0] < UBound($a_Undo) - 1 Then

		$tmp = BoardToString()
		If StringCompare($tmp, $a_Undo[$a_Undo[0]]) <> 0 Then          ;Check if the previous entry is the same as the new one, to avoid duplicate entries
			$a_Undo[0] = $a_Undo[0] + 1
			;CW("A_Undo[0]= " & $a_Undo[0] & " = " & $tmp)
			$a_Undo[$a_Undo[0]] = $tmp
		EndIf
	EndIf

EndFunc   ;==>AddUndo

Func Undo($editmode = -1)

	If $a_Undo[0] >= 1 Then
		;CW("A_Undo[0]= " & $a_Undo[0])
		StringToBoard($a_Undo[$a_Undo[0]])
		$a_Undo[0] = $a_Undo[0] - 1
	EndIf
EndFunc   ;==>Undo

Func GetRandomNess()
	Local $tmp = ";"
	For $y = 0 To $v_BSize - 1
		$z = Random(0, (2 ^ $v_BSize) - 1)
		$tmp = $tmp & $z & ";"
	Next
	Return $tmp
EndFunc   ;==>GetRandomNess

Func LoadLvl($x = 1, $editmode = -1)
	Local $tmp1 = 0
	Local $tmp = ""
	If $x > 0 Then
		While 1
			$tmp = IniRead($inifile, "GAME" & $v_GameType, "Level" & $x, "")
			If $tmp = "" Then
				$x = $x + 1
			Else
				ExitLoop
			EndIf
			If $x > $maxlevels Then
				$x = -1
				ExitLoop
			EndIf
		WEnd
	EndIf

	If FillBoard($tmp, $editmode) = 0 Then Return -1
	Return $x
EndFunc   ;==>LoadLvl

Func InvertLevel()
	For $y = 0 To $v_BSize - 1
		For $x = 0 To $v_BSize - 1
			If GUICtrlRead($GameField[$x][$y]) = Chr(219) Then
				GUICtrlSetData($GameField[$x][$y], " ")
				GUICtrlSetBkColor($GameField[$x][$y], "0xd0d0d0")
			Else
				GUICtrlSetData($GameField[$x][$y], Chr(219))
				GUICtrlSetBkColor($GameField[$x][$y], "0x000000")
			EndIf

		Next
	Next
EndFunc   ;==>InvertLevel

Func FillBoard($lvldat, $editmode = -1)
	Local $nr = 3, $z
	Local $adat = _StringBetween($lvldat, ";", ";")
	$tmp = 1
	If @error > 0 Then
		$adat = _StringBetween(GetRandomNess(), ";", ";")
		$tmp = 0
	EndIf
	For $y = 0 To $v_BSize - 1
		$nr = $adat[$y]
		For $x = $v_BSize - 1 To 0 Step -1
			$z = Bit_Read($nr, $v_BSize - $x)
			If $editmode = 1 Then
				If $z = 0 Then
					GUICtrlSetData($GameField[$x][$y], " ")
					GUICtrlSetBkColor($GameField[$x][$y], "0xd0d0d0")
					$PlayField[$x][$y] = 0
				EndIf

				If $z = 1 Then
					GUICtrlSetData($GameField[$x][$y], Chr(219))
					GUICtrlSetBkColor($GameField[$x][$y], "0x000000")
					$PlayField[$x][$y] = 1
				EndIf
			Else
				GUICtrlSetData($GameField[$x][$y], " ")
				GUICtrlSetBkColor($GameField[$x][$y], "0xd0d0d0")
				If $z = 0 Then $PlayField[$x][$y] = 0
				If $z = 1 Then $PlayField[$x][$y] = 1
			EndIf
		Next
	Next

	;Calculate and fill up the numbers into the Horizontal Input/Edit boxes
	For $y = 0 To $v_BSize - 1
		Local $t = "", $ca = 0, $ad = 0
		For $x = 0 To $v_BSize - 1
			If $PlayField[$x][$y] = 1 Then
				$ca = $ca + 1
				$ad = 0
			Else
				If $ca > 0 Then $t = $t & $ca & " "
				$ca = 0
				$ad = 1
			EndIf
		Next
		If $ad = 0 Then $t = $t & $ca
		GUICtrlSetData($a_Hinput[$y], "")
		GUICtrlSetData($a_Hinput[$y], $t)
	Next

	;Calculate and fill up the numbers into the Vertical Input/Edit boxes
	For $x = 0 To $v_BSize - 1
		Local $t = "", $ca = 0, $ad = 0
		For $y = 0 To $v_BSize - 1
			If $PlayField[$x][$y] = 1 Then
				$ca = $ca + 1
				$ad = 0
			Else
				If $ca > 0 Then $t = $t & $ca & " " & @CRLF
				$ca = 0
				$ad = 1
			EndIf
		Next
		If $ad = 0 Then $t = $t & $ca & " " & @CRLF
		GUICtrlSetData($a_Vinput[$x], "")
		$t = _StringRepeat(@CRLF, (7 - StringCountAll($t, @CRLF))) & $t
		GUICtrlSetData($a_Vinput[$x], $t)

	Next

	Return $tmp
EndFunc   ;==>FillBoard

Func CalcBoard()
	;Calculate the numbers by using the board instead of Array
	For $y = 0 To $v_BSize - 1
		Local $t = "", $ca = 0, $ad = 0
		For $x = 0 To $v_BSize - 1

			Local $tmp = GUICtrlRead($GameField[$x][$y])
			If $tmp = Chr(219) Then
				$ca = $ca + 1
				$ad = 0
			Else
				If $ca > 0 Then $t = $t & $ca & " "
				$ca = 0
				$ad = 1
			EndIf
		Next
		If $ad = 0 Then $t = $t & $ca
		GUICtrlSetData($a_Hinput[$y], "")
		GUICtrlSetData($a_Hinput[$y], $t)
	Next

	For $x = 0 To $v_BSize - 1
		Local $t = "", $ca = 0, $ad = 0
		For $y = 0 To $v_BSize - 1

			Local $tmp = GUICtrlRead($GameField[$x][$y])
			If $tmp = Chr(219) Then
				$ca = $ca + 1
				$ad = 0
			Else
				If $ca > 0 Then $t = $t & $ca & " " & @CRLF
				$ca = 0
				$ad = 1
			EndIf
		Next
		If $ad = 0 Then $t = $t & $ca & " " & @CRLF
		GUICtrlSetData($a_Vinput[$x], "")
		$t = _StringRepeat(@CRLF, (7 - StringCountAll($t, @CRLF))) & $t
		GUICtrlSetData($a_Vinput[$x], $t)
	Next
EndFunc   ;==>CalcBoard

Func CalcWin()                        ;Check the winning conditions !
	Local $diff = 0, $tmpa, $tmpb
	For $y = 0 To $v_BSize - 1
		For $x = 0 To $v_BSize - 1
			$tmpa = $PlayField[$x][$y]
			If GUICtrlRead($GameField[$x][$y]) = Chr(219) Then
				$tmpb = 1
			Else
				$tmpb = 0
			EndIf
			If $tmpa <> $tmpb Then Return 0
		Next
	Next
	If $diff = 0 Then Return 1
	Return 0
EndFunc   ;==>CalcWin

Func StringCountAll($txt, $search)
	If $txt = "" Then Return 0
	Local $q = 0, $x = 1, $y = 0
	Do
		;StringInStr ( "string", "substring" [, casesense = 0 [, occurrence = 1 [, start = 1 [, count]]]] )
		$x = StringInStr($txt, $search, 0, 1, $x)
		If $x > 0 Then
			$y = $y + 1
			$x = $x + StringLen($search)
		ElseIf $x = 0 Then
			$q = 1
		EndIf
		If $x >= StringLen($txt) Then $q = 1
	Until $q = 1
	Return $y
EndFunc   ;==>StringCountAll


Func FindFreeLVL()
	;Returns 1 if a free level slot is found, else 0
	Local $tmp = "", $tmp1 = 0
	Local $found = 0
	For $x = 1 To $maxlevels
		$tmp = IniRead($inifile, "GAME" & $v_GameType, "Level" & $x, "")
		If $tmp = "" Or (StringCountAll($tmp, ";0") = $v_BSize) Then
			$found = 1
			ExitLoop
		EndIf
	Next
	If $found = 0 Then $x = 0
	Return $x
EndFunc   ;==>FindFreeLVL

Func _IsChecked($idControlID)
	;Return BitAND(GUICtrlRead($idControlID), $GUI_CHECKED) = $GUI_CHECKED     ;Returns true or false (oneliner)
	;The lines below convert true and false to numbers - 1 and 0
	Local $x = BitAND(GUICtrlRead($idControlID), $GUI_CHECKED) = $GUI_CHECKED
	If $x = True Then Return 1
	Return 0
EndFunc   ;==>_IsChecked

Func _CheckUncheck($id, $nr)                    ;Radio/Checkboxes
	If $nr = 0 Then
		GUICtrlSetState($id, $GUI_UNCHECKED)
	Else
		GUICtrlSetState($id, $GUI_CHECKED)
	EndIf
EndFunc   ;==>_CheckUncheck


Func Bit_Set($x, $bit)                    ;Set a bit to 1
	;x = variable
	;bit = bit number to set (reminder: bit #1 is the rightmost bit: %101001110[1] <- )
	Return BitOR($x, BitShift(1, -($bit - 1)))
EndFunc   ;==>Bit_Set

Func Bit_Clear($x, $bit)               ;Set a bit to 0
	;x = variable
	;bit = bit number to unset (reminder: bit #1 is the rightmost bit: %101001110[1] <- )
	Return BitAND($x, (BitXOR($x, BitShift(1, -($bit - 1)))))
EndFunc   ;==>Bit_Clear

Func Bit_Read($x, $bit)               ;Reads a bit state of a variable
	;Return the bit state (0 or 1) rightmost bit being 1st
	Return ((BitAND(($x), (BitShift(1, -($bit - 1))))) <> 0) ? 1 : 0
EndFunc   ;==>Bit_Read


Func WM_NOTIFY($hWnd, $msg, $wParam, $lParam)
	Local $tNMHDR, $hWndFrom, $iCode

	$tNMHDR = DllStructCreate($tagNMHDR, $lParam)
	$hWndFrom = DllStructGetData($tNMHDR, "hWndFrom")
	$iCode = DllStructGetData($tNMHDR, "Code")

	Switch $hWndFrom
		Case $ListW
			Switch $iCode
				Case $NM_CUSTOMDRAW
					Local $tCustDraw = DllStructCreate('hwnd hwndFrom;int idFrom;int code;' & _
							'dword DrawStage;hwnd hdc;long rect[4];dword ItemSpec;int ItemState;dword Itemlparam;' & _
							'dword clrText;dword clrTextBk;int SubItem;' & _
							'dword ItemType;dword clrFace;int IconEffect;int IconPhase;int PartID;int StateID;long rectText[4];int Align', _             ;winxp or later
							$lParam)

					Local $iDrawStage = DllStructGetData($tCustDraw, 'DrawStage')

					If $iDrawStage = $CDDS_PREPAINT Then Return $CDRF_NOTIFYITEMDRAW

					Local $iItem = DllStructGetData($tCustDraw, 'ItemSpec')

					If _ArraySearch($aColoredLines, $iItem) > -1 Then
						DllStructSetData($tCustDraw, 'clrTextBk', $aColoredLines[$iItem][1])
						Return $CDRF_NOTIFYITEMDRAW
					EndIf
			EndSwitch
	EndSwitch

	Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_NOTIFY
